/*
	Copyright (c) 2004-2011, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


/*
	Copyright (c) 2004-2011, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["epages.cartridges.de_epages.product.widget.SmartSearchProducts"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.product.widget.SmartSearchProducts"] = true;
dojo.provide("epages.cartridges.de_epages.product.widget.SmartSearchProducts");
dojo.require("epages.cartridges.de_epages.content.widget.SmartSearchInput");

dojo.declare(
	"epages.cartridges.de_epages.product.widget.SmartSearchProducts",
	[epages.cartridges.de_epages.content.widget.SmartSearchInput],
	{
		/**
		 * public properties
		 */
		ViewAction:					'JSONSmartSearchProductAlias',
		inputName :					'NewProduct',
		placeholder: '',

		/**
		 * dojo widget properties
		 */
		templateString:"<span>\n  <span\n    dojoType=\"epages.cartridges.de_epages.content.widget.JsonTagEditor\"\n    availableTags=\"\"\n    dojoAttachPoint=\"SmartSearchBox\"\n    value=\"${value}\"\n    type=\"text\"\n    name=\"${inputName}\"\n    style=\"${inputStyle}\"\n    group=\"\"\n    description=\"\"\n    labelSliceLimit=\"20\"\n    submitOnEnter=\"false\"\n    placeholder=\"${placeholder}\"\n  ></span>\n</span>\n",

		// overloads smartsearchinput's method
		queryObjectAliases: function(callbackArgs) {
			if(!this._lastInputValue) {
				return;
			}
			var inputValue = this._lastInputValue;
			var me = this;
			var json = new epages.io.Json();
			var result = json.loadAsync(this.url,
			function(result){
				if(result.error || !result.data) {
					return;
				}
				// update tageditor available tags ... result.data
				me._lastSeachResultCount = parseInt(result.data.NumResults);

				// mapping for name attribute
				var fixedResults = [];
				var results = result.data.Results;
				var len = result.data.NumResults;

				for(var i=0; i<len; i++) {
					fixedResults[i] = {};
					fixedResults[i].inputvalue = results[i].alias;
					fixedResults[i].labelvalue = results[i].alias;
					if(results[i].name) {
						 fixedResults[i].labelvalue += ' <span class="SmartSearchProductsName">- ' + epages.format.slice(results[i].name, 23, true) + '</span>';
					}
				}
				dojo.publish(me.SmartSearchBox.id + '/onNewSearchResults', [fixedResults, callbackArgs]);
			},
			{
				'ObjectID' 			: this.objectId,
				'ViewAction'		: this.ViewAction,
				'SearchString' 	: inputValue
			});
		}
	}
);

}
